from __future__ import print_function
import math

## compute the distance between points (x1,y1) and (x2,y2)
##
def computeDistance(x1, y1, x2, y2):
    diffx = x2 - x1
    diffy = y2 - y1
    result = math.sqrt(diffx**2 + diffy**2)
    return result

## compute the area of a circle given the coordinate
## of the center (xc,yc) and one point on the perimeter(xp,yp)
##
def computeCircleArea(xc, yc, xp, yp):
    radius = computeDistance(xc, yc, xp, yp)
    result = math.pi * radius**2 
    return result

## compute the area of a rectangle given the coordinates
## of two corner points on opposite ends of one diagonal,(xl,yl) and(xr,yr)
##
def computeRectangleArea(xl, yl, xr, yr):    
    length = computeDistance(xl,yl,xr,yl)
    width = computeDistance(xl,yr,xr,yr)
    result = length * width
    return result
    
px = 0
py = 0
qx = 5
qy = 0

MyCircle = computeCircleArea(px,py,qx,qy)
print(MyCircle)
    
MyDistance = computeDistance(px,py,qx,qy)
print(MyDistance)

MyRectangle = computeRectangleArea(0,0,5,5)
print(MyRectangle)

print(computeRectangleArea(0,0,-3,-3))
print(computeRectangleArea(3,3,-3,-3))

## boundary cases
print(computeCircleArea(0,0,0,0))
print(computeRectangleArea(0,0,0,0))
print(computeRectangleArea(0,3,0,-3))

