from __future__ import print_function

#define two global variables to record the counts of multiplications
count1 = 0
count2 = 0

## function computePower1 computes "base raised to exponent" by making exponent-1
## multiplications using a for-loop and returns this value.
##
def computePower1(base, exponent):
    product = 1
    global count1 #count1 is a global variable 
    count1 = 0    
    
    for i in range(exponent):
        product = product * base
        #for every multiplication done increment global variable count1 
        count1 = count1 + 1

    return product

## function computePower2 computes "base raised to exponent" by exploring the
## binary representation of the exponent to reduce the number of multiplications 
## and returns this value
##
def computePower2(base, exponent):
    product = 1
    global count2 #count1 is a global variable  
    count2 = 0    
    
    while (exponent > 0):
        if(exponent % 2 != 0):
            product = product * base
            #for every multiplication done increment global variable count2
            count2 = count2 + 1
         
        exponent = exponent / 2
        base = base * base
        #for every multiplication increment global variable count2
        count2 = count2 + 1
    
    return product

## given a base and an exponent, call functions computePower1 and computePower2 and
## print the number of multiplications done by each function
##
def comparePower(base, exponent):
    print('Computing',base,'to the power',exponent,'......')
    print('The result of the function computePower1: ', computePower1(base, exponent))
    print('The number of multiplications done by function computePower1: ', count1)
    print('The result of the function computePower2: ', computePower2(base, exponent))
    print('The number of multiplications done by function computePower2: ', count2)
    print('-------------------------------------------------')

comparePower(2,30)
comparePower(5,21)
comparePower(3,63)
comparePower(2,500)
comparePower(2,5000)
